local hm_scoreboard = CV_RegisterVar({
	name = "hm_scoreboard",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hm_scoreboard_humor = CV_RegisterVar({
	name = "hm_scoreboard_humor",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
local hm_scoreboard_verbosestats = CV_RegisterVar({
	name = "showallstats",
	defaultvalue = "Off",
	flags = 0,
	possiblevalue = CV_OnOff
})

local KMPvars = {
	{disp = "Frantic Items", var = "kartfrantic"},
	{disp = "Bumpspark", var = "kmp_bumpspark"},
	{disp = "Hardsneaker", var = "kmp_hardsneakers"},
	{disp = "Long Flashtics", var = "kmp_extendflashtics"},
	{disp = "1.0.4 Spinout", var = "kmp_slowspinout"},
	{disp = "Dropped Item Fuse", var = "kmp_floatingitemfuse"},
	{disp = "Item Limiter", var = "kmp_itemlimiter"},
	{disp = "Orbital Limiter", var = "kmp_orbitlimit"},
	{disp = "Extended Hyudoro", var = "kmp_hyudoro"},
	{disp = "Orbinaut Fuse", var = "kmp_orbinautfuse"},
	{disp = "No Midair Squish", var = "kmp_growthbump"},
	{disp = "Haste", var = "kmp_haste"},
	{disp = "Respawn Anywhere", var = "kmp_respawnpoints"},
	{disp = "Shrink Cleanse", var = "kmp_shrinkcleanse"},
	{disp = "Shrink Pity", var = "kmp_shrinkduration"},
	{disp = "Battle Accel", var = "kmp_battleaccel"},
}


rawset(_G, "HM_Scoreboard_AddTip", function(fug)
	table.insert(fug)
end)

rawset(_G, "HM_Scoreboard_AddMod", function(fug)
	table.insert(server.HMNSBbalance, fug)
end)

local function clan(p, ...)
	if not hm_scoreboard.value then
		CONS_Printf(p, "Esta funcao foi desabilitada pelo host do servidor.")
		return
	end
	if not ... then
		p.HMclan = nil
		CONS_Printf(p, "Tag de clan removida.")
	else
		local fug = table.concat({...}, " ")
		local lowerfug = fug:lower()
		if fug:len() > 10 then
			CONS_Printf(p, "Muito longo.")
			return
		elseif lowerfug:match("staff") or lowerfug:match("admin") or lowerfug:match("krew") or lowerfug:match("mod") or lowerfug:match("~") or lowerfug:match("@") then
			CONS_Printf(p, "Boa tentativa!")
			return
		else
			p.HMclan = fug
			if lowerfug:match("gang") then
				CONS_Printf(p, 'Tag definida para "'..fug..'". :V')
			else
				CONS_Printf(p, 'Tag definida para "'..fug..'".')	
			end
		end
	end
end
COM_AddCommand("clan", clan)

local wrapped = {}

-- I KNOW THERE'S A FUCKIN FUNCTION IN SOURCE FOR THIS
-- WHY IS IT NOT EXPOSED TO LUA
-- LAAAAAAAAAAAAAAAAAAAAAAT
local function wrapString(str, width, v, flags, font)
	local words = {}
	for word in str:gmatch("%S+") do table.insert(words, word) end
	local retlines = {}
	local buffer = words[1]
	for i = 2, #words
		local fug = buffer.." "..words[i]
		if v.stringWidth(fug, flags, font) > width then
			table.insert(retlines, buffer)
			buffer = words[i]
		else
			buffer = fug
		end
	end
	table.insert(retlines, buffer)
	return retlines
end

local function doEscapeCode(str)
	for _, v in pairs(hm_escape)
		str = str:gsub(v.a, v.b)
	end
	return str
end

local function buildTimeString(x)
	if x == nil or x == 99999999 then return "N/A" end
	return ""..string.format("%02d", G_TicsToMinutes(x)).."' "..string.format("%02d", G_TicsToSeconds(x))..'" '..string.format("%02d", G_TicsToCentiseconds(x))
end

addHook("ThinkFrame", function()
	server.HMNSBmsg = $ or {}
	if server.HMNSBbalance == nil then
		server.HMNSBbalance = {}
		for _, v in ipairs(KMPvars)
			table.insert(server.HMNSBbalance, v)
		end
	end
	if leveltime == 1 then
		wrapped = {}
		local fug = true
		local result = nil
		while fug
			fug = false			
			if target.cvar and not CV_FindVar(target.cvar) then
				hm_dprint("Didn't find cvar", target.cvar, "so we're fucking off")
				fug = true
			end
			if target.cvartrue then
				if CV_FindVar(target.cvartrue) then
					if not CV_FindVar(target.cvartrue).value then
						hm_dprint("Found cvar", target.cvartrue, "and it was false, bye")
						fug = true
					end
				else
					hm_dprint("Didn't find cvar", target.cvartrue, "so we're fucking off")
					fug = true
				end
			end
			if target.humor and not hm_scoreboard_humor.value then
				hm_dprint("host hates fun")
				fug = true
			end
		end
		hm_dprint("found", server.HMNSBtip)
	end
end)

local function addscoreboardline(p, ...)
	if not ... then
		CONS_Printf(p, "Usage: hm_scoreboard_addline <text>")
	end
	table.insert(server.HMNSBmsg, doEscapeCode(table.concat({...}, " ")))
end
COM_AddCommand("hm_scoreboard_addline", addscoreboardline, 1)

local function hm_scoreboard_addmod(p, ...)
	if not ... then
		CONS_Printf(p, "Usage: hm_scoreboard_addmod <text>")
	end
	table.insert(server.HMNSBbalance, { disp = doEscapeCode(table.concat({...}, " "))})
end
COM_AddCommand("hm_scoreboard_addmod", hm_scoreboard_addmod, 1)

-- hacked-up TSR scoreboard, WHEEEEEEEEEEEEEEE
-- thanks snu
hud.add(function(v, p, c)
	if not hm_scoreboard.value then
		hud.enable("rankings")
		return
	end
	hud.disable("rankings")
	v.fadeScreen(0xFF00, 16)	-- fade the screen

	-- store highlight colour here for use in the hud throughout
	local hilicol
	if (CV_FindVar("menuhighlight").value)
		hilicol = CV_FindVar("menuhighlight").value
	elseif (modeattacking)
		hilicol = V_ORANGEMAP
	else
		hilicol = ((gametype == GT_RACE) and V_SKYMAP or V_REDMAP)
	end
	
	if false and consoleplayer and (consoleplayer == server or IsPlayerAdmin(consoleplayer)) then
		local reverseplayers = {}
		for k,v in players.iterate do
		   reverseplayers[v] = k
		end
	end
	
	-- draw lap count and game speed
	if not G_BattleGametype() then
		v.drawString(64, 8, "LAP COUNT", 0, "center")
		v.drawString(64, 16, (numlaps), hilicol, "center")
		v.drawString(256, 8, "GAME SPEED", 0, "center")
		v.drawString(256, 16, CV_FindVar("kartspeed").string, hilicol, "center")
	end
	
	-- draw line between gametypeinfo and teams
	local dupadjust = (v.width()/v.dupx())
	local duptweak = (dupadjust - 320)/2	-- BASEDVIDWIDTH = 320 (based on what?)
	v.drawFill(1-duptweak, 26, dupadjust-2, 1, 0)	-- horizontal
	v.drawFill(160, 26, 1, 162, 0)	-- vertical
	
	v.drawString(4, 188, hm_trim(mapheaderinfo[gamemap].lvlttl.." "..mapheaderinfo[gamemap].zonttl).." - "..mapheaderinfo[gamemap].subttl, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")

	-- draw right pane
	local fy = 28
	local fx = 163
	local off = 0 -- right pane line offset OH GOD this code is everywhere
	local motd = CV_FindVar("hm_motd")
	if motd and motd.value then
		v.drawString(fx, fy, doEscapeCode(CV_FindVar("hm_motd_name").string), V_ALLOWLOWERCASE, "thin")
		v.drawString(fx, fy+10, "\134Contato: "..doEscapeCode(CV_FindVar("hm_motd_contact").string), V_ALLOWLOWERCASE, "small")
		off = $ + 4
	end
	
	local restat = CV_FindVar("hm_restat")
	
	if server.HMNSBmsg then
		for key, val in ipairs(server.HMNSBmsg)
			v.drawString(fx, fy+(off*5), val, V_ALLOWLOWERCASE, "small")
			off = $ + 1
		end
		off = $ + 1
	end
	
	local drew = false
	local dupes = {}

	for key, val in ipairs(server.HMNSBbalance)
		local drawthatshit = false
		if not val.var then
			drawthatshit = true
		elseif CV_FindVar(val.var) then
			if CV_FindVar(val.var).value then drawthatshit = true end
		end
		if drawthatshit and (not dupes[val]) then
			if not drew then
				v.drawString(fx, fy+(5*off), "\134Gameplay / Balance Changes:", V_ALLOWLOWERCASE, "thin")
				off = $ * 2 + 4
			end
			drew = true
			if off % 2 then
				v.drawString(fx+77, fy+(off/2*5), val.disp, V_ALLOWLOWERCASE, "small")
			else
				v.drawString(fx, fy+(off/2*5), val.disp, V_ALLOWLOWERCASE, "small")
			end
			off = $ + 1
			dupes[val] = true
		end
	end
	
	if drew then off = ($ / 2) + ($ % 2) + 1 end
	
	if server.HMNSBtip then
		v.drawString(fx, fy+(off*5), "\134Did You Know?", V_ALLOWLOWERCASE, "thin")
		off = $ + 2
		if #wrapped < 1 then
			hm_dprint("regenerating wrapped tip")
			wrapped = wrapString(server.HMNSBtip, 150, v, V_ALLOWLOWERCASE, "small")
		end
		for _, val in ipairs(wrapped)
			v.drawString(fx, fy+(off*5), val, V_ALLOWLOWERCASE, "small")
			off = $ + 1
		end
		off = $ + 1
	end

	-- draw players
	local tsr_rankings = {}
	for p in players.iterate
		if (p and p.valid) and not p.spectator
			table.insert(tsr_rankings, p)
		end
	end
	table.sort(tsr_rankings, function(a, b) return a.kartstuff[k_position] < b.kartstuff[k_position] end)
	for p in players.iterate
		if p.spectator
			table.insert(tsr_rankings, p)
		end
	end
	if not #tsr_rankings then return end

	for i = 1, #tsr_rankings
		local p = tsr_rankings[i]
		local hy = 28 + (i-1)*10
		local specflag = (p.spectator or p.rs_check2) and V_50TRANS or 0

		-- player ping:
		if (p ~= server)  -- the server doesnt have a ping
		and (netgame)	-- we obviously need to be in a netgame too
			-- my hopes with writing this code is that it's so bad that I'm never allowed to write ping related code ever again
			local ping = p.ping
			-- get the ping patch we'll use
			local ping_gfxnum, ping_values = 1, {2, 4, 7, 10}
			for i = 1, #ping_values
				if (ping >= ping_values[i]) then ping_gfxnum = i+1 end
			end
			-- sadly p.cmd.latency caps at 11 so it cant go any higher without hacks so huge that I cant be assed
			v.draw(3, hy, v.cachePatch("HMPING"..ping_gfxnum), specflag)
		end
		-- rank:
		if not p.spectator then
			v.drawString(29, hy+1, p.kartstuff[k_position], 0, "right")
		end
		-- draw skin icon
		if (p.mo and p.mo.valid) then
			local pp = skins[p.mo.skin].facerank
			local cmap = v.getColormap(p.mo.skin, p.mo.color)
			local dieflag = 0
			if p.mo.colorized then cmap = v.getColormap(TC_RAINBOW, p.mo.color) end
			if G_BattleGametype() and p.kartstuff[k_bumper] <= 0 then
				cmap = v.getColormap(TC_RAINBOW, SKINCOLOR_GREY)
				dieflag = V_50TRANS
			end
			v.drawScaled(30<<FRACBITS, (hy+1)<<FRACBITS, FRACUNIT/2, v.cachePatch(pp), specflag|dieflag, cmap)
		end
		-- name: c[p.tsr_team]..p.name
		local c = 0
		local index = p.tsr_team or 6
		local fugname = ""
		if p.HMclan then fugname = $.."\140"..p.HMclan.." \128" end
		--if p.HMclan then fugname = $..hm_color[p.skincolor]..p.HMclan.." | \128" end
		if p == consoleplayer then fugname = $..hm_color[p.skincolor] end
		if p.name == nil then
			fugname = $.."Glitched player :?"
		else
			fugname = $..p.name
		end
		while v.stringWidth(fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin") > 100
			fugname = $:sub(1, -2)
		end
		if consoleplayer and (consoleplayer == server or IsPlayerAdmin(consoleplayer)) then
			fugname = $.." \x86["..#p.."]"
		end
		v.drawString(39, hy, fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin")
		if (p.mo and p.mo.valid) then
			if (restat.value and p.HMRs) or hm_scoreboard_verbosestats.value then
				local restatflag = (hm_scoreboard_verbosestats.value and p.HMRs) and V_YELLOWMAP or 0
				v.drawString(29, hy, p.kartspeed, restatflag, "small")
				v.drawString(39, hy+6, p.kartweight, restatflag, "small-right")
			end
		end
		-- points:
		local points = ""
		if p.spectator then
			if p.pflags & PF_WANTSTOJOIN then
				points = "WAIT"
			else
				points = "SPEC"
			end
		elseif p.rs_check2 then
			points = "RAGE"
		elseif p.pflags & PF_TIMEOVER then
			points = "NO CONTEST."
		elseif G_BattleGametype() then
			points = p.marescore
		elseif not p.exiting then
			points = "LAP "..(p.laps+1)
		else
			points = buildTimeString(p.realtime)
		end
		v.drawString(157, hy, points, (p.exiting and hilicol or 0)|V_6WIDTHSPACE|specflag, "thin-right")
	end
end, "scores")